<?php
/*
Writen by <m@d> 2010
Working with INI File

array readIniFile(string filename)
 INI     :
Array
(
    [Section1] => Array
        (
            [Field11] => Value11
            [Field12] => Value12
            [Field13] => Value13
        )
    [Section2] => Array
        (
            [Field21] => Value21
            [Field22] => Value22
            [Field23] => Value23
        )
    [Section3] => Array
        (
            [Field31] => Value31
            [Field32] => Value32
            [Field33] => Value33
        )
)

string readIniData(string filename, string section, string field)
   field  section.    

array readIniSection( string filename, string section)
  section    :
Array
{
            [Field1] => Value1
            [Field2] => Value2
)

bool writeIniFile(string filename, array arr)
    ini  filename
 arr:
Array
(
    [Section1] => Array
        (
            [Field11] => Value11
            [Field12] => Value12
            [Field13] => Value13
        )
    [Section2] => Array
        (
            [Field21] => Value21
            [Field22] => Value22
            [Field23] => Value23
        )
    [Section3] => Array
        (
            [Field31] => Value31
            [Field32] => Value32
            [Field33] => Value33
        )
)
    true.   false

bool writeIniData( string filename, string section, string field, string value) 
    field   value  section.      ,   


*/
function readIniFile($filename) {
    if (!file_exists($filename)) die('File '.$filename.' not found');
    if (!is_readable($filename)) die('File read error. Check the access');
    $str=file_get_contents($filename);
    $arr=explode("\n",$str);
    unset($lastsection);
    foreach($arr as $s) {
        $s=preg_replace('/^\s+/','',$s);
        $s=preg_replace('/\s+$/','',$s);
        if (empty($s)) continue;
        if (preg_match('/\[(.+)\]/',$s,$m)) {
	    $sec=strtolower($m[1]);
	    $res[$sec]=array();
	    $lastsection=$sec;
	
        }
	else {
	    if (!isset($lastsection)) die('Error fromat of ini file');
	    list($f,$v)=split('=',$s);
	    $res[$lastsection][strtolower($f)]=$v;
        }
    }
    return $res;
}

function readIniData($filename,$section,$field) {
    $arr=readIniFile($filename);
    $section=strtolower($section);
    $field=strtolower($field);
    if (!isset($arr[$section][$field])) return false;
    return $arr[$section][$field];
}

function readIniSection($filename,$section) {
    $arr=readIniFile($filename);
    $section=strtolower($section);
    if (!isset($arr[$section])) return false;
    return $arr[$section];
}

function writeIniFile($filename,$arr) {
    if (count($arr)===0) return false;
    $f = fopen($filename, "w");
    if ($f===false) return false;
    foreach($arr as $key=>$sec) {
	fwrite($f,"[$key]\n");
	foreach($sec as $field=>$val) {
	    fwrite($f,"$field=$val\n");
	}
	fwrite($f,"\n");
    }
    fclose($f);
    return true;
}

function writeIniData($filename,$section,$field,$value) {
    if (empty($section) or empty($field) or empty($value)) 
	return false;
    $arr=readIniFile($filename);
    $arr[strtolower($section)][strtolower($field)]=$value;
    if (!writeIniFile($filename,$arr)) return false;
    return true;
}

#print_r(readIniFile('/qwe.ini'));
//$arr=readIniFile('/qwe.ini');
if (!writeIniData('/q.ini','MySection','NewField','newValue')) echo "Error writeing file\n";;
?>
